

.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			
LOOP_COUNT	= 10000
option scoped


 l_htodw	PROTO : DWORD
 l_a2l       proto :dword 
Axhex2dw  PROTO : DWORD
Axhex2dw1  PROTO : DWORD
Axhex2dw2  PROTO : DWORD
Axhex2dw3  PROTO : DWORD
Axhex2dw3_1  PROTO : DWORD
Axhex2dw4  PROTO : DWORD
Axhex2dw_MMX  PROTO : DWORD
Axhex2dw_MMX2  PROTO : DWORD
Axhex2dw_SSE  PROTO : DWORD
Axhex2dw_Unrolled_AMD PROTO :DWORD
Axhex2dw_Unrolled PROTO :DWORD


Alex_Short_Hutch PROTO :DWORD
Axhex2dw_Hutch2 PROTO :DWORD

Hex2dwLingoSSE PROTO :DWORD
lingo_htodw PROTO:DWORD

ax_jj_htodw PROTO :DWORD

krbhtodw PROTO :DWORD


.data

align  16
hexstring    db  "ABCDEF01",0

; Lingo's integer long version look-up table
align 16
lingo_lookup_table_start label byte
    l_tbl_8 dd 0,10000000h,20000000h,30000000h,40000000h,50000000h,60000000h,70000000h,80000000h,90000000h
          dd 0,0,0,0,0,0,0,0A0000000h,0B0000000h,0C0000000h,0D0000000h,0E0000000h,0F0000000h
          dd 26 Dup(0),0A0000000h,0B0000000h,0C0000000h,0D0000000h,0E0000000h,0F0000000h
    l_tbl_7 dd 0,1000000h,2000000h,3000000h,4000000h,5000000h,6000000h,7000000h,8000000h,9000000h
          dd 0,0,0,0,0,0,0,0A000000h,0B000000h,0C000000h,0D000000h,0E000000h,0F000000h
          dd 26 Dup(0),0A000000h,0B000000h,0C000000h,0D000000h,0E000000h,0F000000h
    l_tbl_6 dd 0,100000h,200000h,300000h,400000h,500000h,600000h,700000h,800000h,900000h
          dd 0,0,0,0,0,0,0,0A00000h,0B00000h,0C00000h,0D00000h,0E00000h,0F00000h
          dd 26 Dup(0),0A00000h, 0B00000h,0C00000h,0D00000h,0E00000h,0F00000h
   l_tbl_5 dd 0,10000h,20000h,30000h,40000h,50000h,60000h,70000h,80000h,90000h
          dd 0,0,0,0,0,0,0,0A0000h,0B0000h,0C0000h,0D0000h,0E0000h,0F0000h
          dd 26 Dup(0),0A0000h, 0B0000h,0C0000h,0D0000h,0E0000h,0F0000h
     l_tbl_4 dd 0,1000h,2000h,3000h,4000h,5000h,6000h,7000h,8000h,9000h
          dd 0,0,0,0,0,0,0,0A000h,0B000h,0C000h,0D000h,0E000h,0F000h
          dd 26 Dup(0),0A000h,0B000h,0C000h,0D000h,0E000h,0F000h
    l_tbl_3 dd 0,100h,200h,300h,400h,500h,600h,700h,800h,900h
          dd 0,0,0,0,0,0,0,0A00h,0B00h,0C00h,0D00h,0E00h,0F00h
          dd 26 Dup(0),0A00h,0B00h,0C00h,0D00h,0E00h,0F00h
    l_tbl_2 dd 0,10h,20h,30h,40h,50h,60h,70h,80h,90h
          dd 0,0,0,0,0,0,0,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h
          dd 26 Dup(0),0A0h,0B0h,0C0h,0D0h,0E0h,0F0h
    l_tbl_1 dd 0,1,2,3,4,5,6,7,8,9
          dd 0,0,0,0,0,0,0,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
          dd 26 Dup(0),0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
lingo_lookup_table_end label byte
lingo_lookup_table_size EQU lingo_lookup_table_end-lingo_lookup_table_start



;align 16
;numstring          db  "1234543210",0
;align 16
;negnumstring   db  "-1234543210",0

.code
start:

	invoke GetCurrentThread
	invoke SetThreadAffinityMask,eax,1
	invoke Sleep,0
	
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	
	print chr$(13,10)
	
	call @ax_jj_htodw_table_init
	
	REPEAT 3

	invoke Sleep, 200
	
	comment ~
	
	invoke Axhex2dw1, addr  hexstring
	print hex$(eax),9,"Result of 1",13,10
	invoke Axhex2dw2, addr  hexstring
	print hex$(eax),9,"Result of 2",13,10
	invoke Axhex2dw3, addr  hexstring
	print hex$(eax),9,"Result of 3",13,10
	
	invoke Axhex2dw_Unrolled, addr  hexstring
	print hex$(eax),9,"Result of Unrolled",13,10
	invoke Axhex2dw_Unrolled_AMD, addr  hexstring
	print hex$(eax),9,"Result of Unrolled (AMD)",13,10
	~
	
	print chr$(13,10,13,10)
	
	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_Unrolled, addr  hexstring
    counter_end
	     print str$(eax), 9, "cycles for Fast version", 13, 10

	cpuid
	invoke Sleep,0
	
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_Unrolled_AMD, addr  hexstring
    counter_end
		print str$(eax), 9, "cycles for Fast version under AMD", 13, 10


	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw1, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Small 1", 13, 10


	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw2, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Small 2", 13, 10
	    
	
	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw3, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Small 3", 13, 10
	    
	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw3_1, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Small 3.1", 13, 10
	    
	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw4, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Small 4", 13, 10

	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_MMX, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for MMX 1", 13, 10

	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_MMX2, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for MMX 2", 13, 10

	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_SSE, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for SSE1", 13, 10
	    
	    
	    print chr$(13,10),"Other's Versions:",13,10
	    
	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Alex_Short_Hutch, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Axhex2dw improved by Hutch (1)", 13, 10

	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw_Hutch2, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Axhex2dw improved by Hutch (2)", 13, 10
	
	print chr$(13,10)

	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Hex2dwLingoSSE, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Lingo's SSE version", 13, 10	

	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke lingo_htodw, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Lingo's BIG integer version", 13, 10
	    
	cpuid
	invoke Sleep,0

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke ax_jj_htodw, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Jochen's WORD-Indexed version", 13, 10


	cpuid
	invoke Sleep,0
	
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke krbhtodw, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Dave's version (with minor changes)", 13, 10
	    
	        
	    
    




	ENDM
	

	print chr$(13,10)
	print "==========", 13, 10
	print "Codesizes:", 13, 10
	print "Axhex2dw_Unrolled:", 9
	mov   eax, Axhex2dw_endp_Unrolled
	sub	  eax, Axhex2dw_Unrolled
	print str$(eax), 13, 10

	print "Axhex2dw_Unrolled_AMD:", 9
	mov   eax, Axhex2dw_endp_Unrolled_AMD
	sub	  eax, Axhex2dw_Unrolled_AMD
	print str$(eax), 13, 10
	
	
	print "Axhex2dw1 - 1:", 9
	mov   eax, Axhex2dw1_endp
	sub	  eax, Axhex2dw1
	print str$(eax), 13, 10
	
	print "Axhex2dw2 - 2:", 9
	mov   eax, Axhex2dw2_endp
	sub	  eax, Axhex2dw2
	print str$(eax), 13, 10
	
	print "Axhex2dw3 - 3:", 9
	mov   eax, Axhex2dw3_endp
	sub	  eax, Axhex2dw3
	print str$(eax), 13, 10
	
	print "Axhex2dw3_1 - 3.1:", 9
	mov   eax, Axhex2dw3_1_endp
	sub	  eax, Axhex2dw3_1
	print str$(eax), 13, 10
	
	print "Axhex2dw3 - 4:", 9
	mov   eax, Axhex2dw4_endp
	sub	  eax, Axhex2dw4
	print str$(eax), 13, 10
	
	print "Axhex2dw_MMX:", 9
	mov   eax, Axhex2dw_MMX_endp
	sub	  eax, Axhex2dw_MMX
	print str$(eax), 13, 10
	
	print "Axhex2dw_MMX2:", 9
	mov   eax, Axhex2dw_MMX2_endp
	sub	  eax, Axhex2dw_MMX2
	print str$(eax), 13, 10
	
	print "Axhex2dw_SSE:", 9
	mov   eax, Axhex2dw_SSE_endp
	sub	  eax, Axhex2dw_SSE
	print str$(eax), 13, 10

	print "Alex_Short_Hutch:", 9
	mov   eax, Alex_Short_Hutch_endp
	sub	  eax, Alex_Short_Hutch
	print str$(eax), 13, 10

	print "Axhex2dw_Hutch2:", 9
	mov   eax, Axhex2dw_Hutch2_endp
	sub	  eax, Axhex2dw_Hutch2
	print str$(eax), 13, 10

	print "Hex2dwLingoSSE:", 9
	mov   eax, Hex2dwLingoSSE_endp
	sub	  eax, Hex2dwLingoSSE
	print str$(eax), 13, 10
	
	print "lingo_htodw:", 9
	mov   eax, lingo_htodw_endp
	sub	  eax, lingo_htodw
	add eax,lingo_lookup_table_size
	print str$(eax), 13, 10

	print "ax_jj_htodw:", 9
	mov   eax, ax_jj_htodw_endp
	sub	  eax, ax_jj_htodw_s
	print str$(eax), 13, 10
	
	print "krbhtodw:", 9
	mov   eax, krbhtodw_endp
	sub	  eax, krbhtodw
	print str$(eax), 13, 10

	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp



option prologue:none
option epilogue:none	


align 16

Axhex2dw1    proc STDCALL lpszStr:DWORD
	;int 3
	
	;binary code of
	;mov edx,[esp+(DWORD)4]
	;db 8bh,94h,24h,4,0,0,0
	
	mov edx,[esp+4]
	
	mov eax,0
	
	;binary code of
	;mov [esp+(DWORD)4],edi
	db 89h,0bch,24h,4,0,0,0
	
	;binary code of
	;movzx ecx,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,4Ah,0
	
	;binary code of
	;movzx edi,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,7Ah,0
	
	;test ecx,ecx
	;binary code of
	;cmp ecx,(DWORD)0
	db 81h,0F9h,0,0,0,0
	
	
	jz @done

	; main loop
	@@:	; loop aligned by 16 bytes
	and edi,1111Y
	shr ecx,6
	shl eax,4
	lea ecx,[ecx+ecx*8]
	add edx,1
	lea edi,[edi+ecx]
	add eax,edi
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx edi,byte ptr [edx]
	cmp ecx,0
	jnz @B
	
	@done:
	mov edi,[esp+4]
	ret 4
Axhex2dw1    endp
Axhex2dw1_endp:

align 16
Axhex2dw2    proc STDCALL lpszStr:DWORD
	;int 3

	;binary code of
	;mov edx,[esp+(DWORD)4]
	;db 8bh,94h,24h,4,0,0,0
	
	mov edx,[esp+4]
	
	mov eax,0
	
	;binary code of
	;mov [esp+(DWORD)4],edi
	db 89h,0bch,24h,4,0,0,0
	
	;binary code of
	;movzx ecx,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,4Ah,0
	;movzx ecx,byte ptr [edx]
	
	;binary code of
	;movzx edi,byte ptr [edx+(BYTE)0]
	db 0Fh,0B6h,7Ah,0
	
	;test ecx,ecx
	;binary code of
	;cmp ecx,(DWORD)0
	db 81h,0F9h,0,0,0,0
	jz @done

	; main loop
	@@:	; loop aligned by 16 bytes
	and edi,1111Y
	shr ecx,6
	add edx,1
	shl eax,4
	lea edi,[edi+ecx*8]
	add eax,ecx
	add eax,edi
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx edi,byte ptr [edx]
	cmp ecx,0
	jnz @B
	;~
	@done:
	mov edi,[esp+4]
	ret 4
Axhex2dw2    endp
Axhex2dw2_endp:

align 16
db 12 dup(0CCh)
Axhex2dw3    proc STDCALL lpszStr:DWORD


	mov edx,[esp+4]
	
	xor eax,eax

	mov [esp+4],ebx

	movzx ecx,byte ptr [edx]

	movzx ebx,byte ptr [edx]
	
	test ecx,ecx
	jz @done

	;comment ~
	; main loop
	@@:	; loop aligned by 16 bytes
	and ebx,1111Y
	add edx,1
	shr ecx,6
	shl eax,4
	lea ebx,[ebx+ecx*8]
	add eax,ecx
	add eax,ebx
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx ebx,byte ptr [edx]
	cmp ecx,0
	jnz @B
	;~
	@done:
	mov ebx,[esp+4]
	ret 4
Axhex2dw3    endp
Axhex2dw3_endp:

align 16
db 12 dup(0CCh)
Axhex2dw3_1    proc STDCALL lpszStr:DWORD


	mov edx,[esp+4]
	
	xor eax,eax

	mov [esp+4],ebx

	movzx ecx,byte ptr [edx]

	movzx ebx,byte ptr [edx]
	
	test ecx,ecx
	jz @done

	;comment ~
	; main loop
	@@:	; loop aligned by 16 bytes
	and ebx,1111Y
	add edx,1
	shr ecx,6
	shl eax,4
	lea ebx,[ebx+ecx*8]
	add eax,ecx
	add eax,ebx
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx ebx,byte ptr [edx]
	test ecx,ecx
	jnz @B
	;~
	@done:
	mov ebx,[esp+4]
	ret 4
Axhex2dw3_1    endp
Axhex2dw3_1_endp:

align 16
db 8 dup(0CCh)
Axhex2dw4    proc STDCALL lpszStr:DWORD


	mov edx,[esp+4]
	
	xor eax,eax

	mov [esp+4],ebx

	movzx ecx,byte ptr [edx]

	movzx ebx,byte ptr [edx]
	
	;binary code of
	;cmp ecx,(DWORD)30h
	db 81h,0F9h,30h,0,0,0
	jb @done

	;comment ~
	; main loop
	@@:	; loop aligned by 16 bytes
	and ebx,1111Y
	add edx,1
	shr ecx,6
	shl eax,4
	lea ebx,[ebx+ecx*8]
	add eax,ecx
	add eax,ebx
	@preloop:
	movzx ecx,byte ptr [edx]
	movzx ebx,byte ptr [edx]
	cmp ecx,30h
	jnb @B
	;~
	@done:
	mov ebx,[esp+4]
	ret 4
Axhex2dw4    endp
Axhex2dw4_endp:


align 16
Axhex2dw_MMX_s:
Axhex2dw_MMX    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]
	
ifndef XMM_USED
	OPSIZE TEXTEQU <qword ptr>
else
	OPSIZE TEXTEQU <xmmword ptr>
endif



	movq mm0,OPSIZE [edx]
	movq mm1,OPSIZE [edx]
	movq mm2,OPSIZE [edx]
	
	pand mm0,OPSIZE @maskDigits;mm6
	pand mm1,OPSIZE @maskIsLetter;mm7
	psubd mm2,OPSIZE @an30Sub
	

	psrld mm1,3
	paddd mm0,mm1
	
	pmovmskb ecx,mm2
	
	psrld mm1,3
	paddd mm0,mm1
	
	bsf ecx,ecx

	movq mm5,mm0
	psllw mm0,8
	psrlw mm5,4
	
	paddd mm5,mm0
	psrld mm5,4
	packuswb mm5,mm0
	movzx ecx,byte ptr[@thetable+ecx]
	movd eax,mm5
	bswap eax
	shr eax,cl
	
	ret 4
	
	align 16
@maskIsLetter:	
		dq 4040404040404040h
@maskDigits:
		dq 0F0F0F0F0F0F0F0Fh
@an30Sub:	
		dq 3030303030303030h
@thetable:	
		db 32,28,24,20,16,12,8,4
	
Axhex2dw_MMX    endp
Axhex2dw_MMX_endp:


align 16
Axhex2dw_MMX2    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]
	
ifndef XMM_USED
	OPSIZE TEXTEQU <qword ptr>
else
	OPSIZE TEXTEQU <xmmword ptr>
endif



	movq mm0,OPSIZE [edx]
	movq mm1,OPSIZE [edx]
	movq mm2,OPSIZE [edx]
	
	pand mm0,OPSIZE @maskDigits;mm6
	pand mm1,OPSIZE @maskIsLetter;mm7
	psubd mm2,OPSIZE @an30Sub
	

	psrld mm1,3
	paddd mm0,mm1
	
	pmovmskb ecx,mm2
	
	psrld mm1,3
	paddd mm0,mm1
	
	bsf ecx,ecx
	neg ecx
	lea ecx,[ecx*4+8*4]

	movq mm5,mm0
	psllw mm0,8
	psrlw mm5,4
	

	
	paddd mm5,mm0
	psrld mm5,4
	packuswb mm5,mm0
	movd eax,mm5
	bswap eax
	shr eax,cl
	
	ret 4
	
	align 16
@maskIsLetter:	
		dq 4040404040404040h
@maskDigits:
		dq 0F0F0F0F0F0F0F0Fh
@an30Sub:	
		dq 3030303030303030h
	
Axhex2dw_MMX2    endp
Axhex2dw_MMX2_endp:


align 16
Axhex2dw_SSE    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]
	
ifndef XMM_USED
	OPSIZE TEXTEQU <qword ptr>
else
	OPSIZE TEXTEQU <xmmword ptr>
endif



	movq xmm0,OPSIZE [edx]
	movq xmm1,OPSIZE [edx]
	movq xmm2,OPSIZE [edx]
	
	pand xmm0,OPSIZE @maskDigits;xmm6
	pand xmm1,OPSIZE @maskIsLetter;xmm7
	psubd xmm2,OPSIZE @an30Sub
	

	psrld xmm1,3
	paddd xmm0,xmm1
	
	pmovmskb ecx,xmm2
	
	psrld xmm1,3
	paddd xmm0,xmm1
	
	bsf ecx,ecx
	neg ecx
	lea ecx,[ecx*4+8*4]

	movq xmm5,xmm0
	psllw xmm0,8
	psrlw xmm5,4
	

	
	paddd xmm5,xmm0
	psrld xmm5,4
	packuswb xmm5,xmm0
	movd eax,xmm5
	bswap eax
	shr eax,cl
	
	ret 4
	
	align 16
@maskIsLetter:	
		dq 4040404040404040h
		dq 0
@maskDigits:
		dq 0F0F0F0F0F0F0F0Fh
		dq 0
@an30Sub:	
		dq 3030303030303030h
		dq 0
	
Axhex2dw_SSE    endp
Axhex2dw_SSE_endp:


align 16
Axhex2dw_Unrolled    proc STDCALL lpszStr:DWORD
;int 3
	mov edx,[esp+4]

	UNIT TEXTEQU <DWORD>
	
	@l1:
	movzx ecx,byte ptr [edx]
	cmp ecx,0
	jz @done
	mov eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+1]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+2]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+3]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+4]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+5]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+6]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	movzx ecx,byte ptr [edx+7]
	shl eax,4
	cmp ecx,0
	jz @done
	add eax,[@@table+ecx*4-(30h*4)]
	
	ret 4
	


	@done:
	shr eax,4
	ret 4

	align 16
	@@table:
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
		
Axhex2dw_Unrolled    endp
Axhex2dw_endp_Unrolled:


align 16
Axhex2dw_Unrolled_AMD    proc STDCALL lpszStr:DWORD
	mov edx,[esp+4]
	push esi
	push edi
	push ebx

	UNIT TEXTEQU <DWORD>
	
	mov eax,0
	
	movzx esi,byte ptr [edx]
	movzx edi,byte ptr [edx+1]

	cmp esi,0
	jz @done
	mov eax,dword ptr [@@table+esi*UNIT-(30h*4)]
	movzx ecx,byte ptr [edx+2]
	cmp edi,0
	jz @done
	shl eax,4

	add eax,dword ptr [@@table+edi*UNIT-(30h*4)]
	movzx ebx,byte ptr [edx+3]
	cmp ecx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ecx*UNIT-(30h*4)]
	movzx esi,byte ptr [edx+4]
	cmp ebx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ebx*UNIT-(30h*4)]
	movzx edi,byte ptr [edx+5]
	cmp esi,0
	jz @done
	shl eax,4
	
	
	
	add eax,dword ptr [@@table+esi*UNIT-(30h*4)]
	movzx ecx,byte ptr [edx+6]
	cmp edi,0
	jz @done
	shl eax,4

	add eax,dword ptr [@@table+edi*UNIT-(30h*4)]
	movzx ebx,byte ptr [edx+7]
	cmp ecx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ecx*UNIT-(30h*4)]
	cmp ebx,0
	jz @done
	shl eax,4
	
	add eax,dword ptr [@@table+ebx*UNIT-(30h*4)]


	@done:
	pop ebx
	pop edi
	pop esi
	ret 4

	align 16
	@@table:
	UNIT 0,1,2,3,4,5,6,7,8,9
	UNIT 7 dup (-1)
	UNIT 10,11,12,13,14,15
	UNIT 26 dup(-1)
	UNIT 10,11,12,13,14,15
		
Axhex2dw_Unrolled_AMD    endp
Axhex2dw_endp_Unrolled_AMD:



align 16

Alex_Short_Hutch proc lpszStr:DWORD

    mov edx, [esp+4]
    mov eax, 0
    mov [esp+4], edi
    movzx edi, BYTE PTR [edx]
    movzx ecx, BYTE PTR [edx]
    test ecx, ecx
    jz lbl1

  lbl0:
    and edi, 15
    shr ecx, 6
    add edx, 1
    shl eax, 4
    lea edi, [edi+ecx*8]
    add eax, ecx
    add eax, edi
    movzx ecx, BYTE PTR [edx]
    movzx edi, BYTE PTR [edx]
    test ecx, ecx
    jnz lbl0

  lbl1:
    mov edi, [esp+4]
    ret 4

Alex_Short_Hutch    endp
Alex_Short_Hutch_endp:

align 16
Axhex2dw_Hutch2    proc STDCALL lpszStr:DWORD
    mov edx,[esp+4]
    xor eax,eax
    mov [esp+4],edi
push ESI
xor ESI,ESI
   
    jmp @preloop
   
    ; main loop
    @@:    ; loop aligned by 16 bytes
    and edi,1111Y
    shr ecx,6
    add edx,1
lea eax,[esi+eax*4]
    lea edi,[edi+ecx*8]
lea eax,[eax*4+ecx]
    add eax,edi
    @preloop:
    movzx ecx,byte ptr [edx]
    movzx edi,byte ptr [edx]
    cmp ecx,0
    jnz @B
    @done:
pop ESI
    mov edi,[esp+4]
    ret 4
Axhex2dw_Hutch2    endp
Axhex2dw_Hutch2_endp:

align 16
Hex2dwLingoSSE_s:
Hex2dwLingoSSE proc src
	pop edx
	pop eax
	pshufw mm0,[eax], 01Bh
	   movq	 mm2, mask30h
	   ;pxor	 mm2, mm2
	pshufw mm1,mm0, 0E4h
	paddb mm0, maskD0h
	pcmpgtb mm1,mask39h
	   pcmpgtb mm2,[eax]
	   ;pcmpeqb mm2, [eax]	
	pand mm1,maskF9h
	paddb mm0,mm1
	pand mm0,mask0Fh
	pshufw mm1,mm0, 0E4h
	psrlw mm0,8
	psllw mm1,4
	pmovmskb ecx, mm2
	por mm0,mm1
	pand mm0,maskFFh
	packuswb mm0,mm0
	test		ecx, ecx			
	movd	eax,mm0
	jne		@f
	jmp		edx
	tbls db 31,28,24,20,16,12,8,4
align 16
@@:
	bsf		ecx, ecx 
	movzx	ecx, byte ptr [tbls+ecx]	
	shr		eax, cl
	jmp		edx
	
	

align 16
mask39h dq 3939393939393939h
maskFFh dq 00FF00FF00FF00FFh
maskD0h dq 0D0D0D0D0D0D0D0D0h
maskF9h dq 0F9F9F9F9F9F9F9F9h
mask0Fh dq 0F0F0F0F0F0F0F0Fh
mask30h dq 3030303030303030h
	
Hex2dwLingoSSE endp
Hex2dwLingoSSE_endp:


align 16
lingo_htodw proc lpString:DWORD

  ; -------------------------------
  ; Lingo long version (decyphered)
  ; -------------------------------
  ; -------------------------------
  ; Lingo long version (decyphered)
  ; -------------------------------

    mov edx, [esp+4]
    push ebx
    mov ebx, [edx]
    xor ecx, ecx 	
    add cl, bl
    jz End1
    mov eax, [l_tbl_8+ecx*4-192] 
    xor ecx, ecx 	
    add cl, bh
    jz End2
    mov edx, [edx+4]
    add eax, [l_tbl_7+ecx*4-192] 
    xor ecx, ecx 	
    shr ebx, 16
    add cl, bl
    jz End3
    add eax, [l_tbl_6+ecx*4-192] 
    xor ecx, ecx 	
    add cl, bh
	jz	 End4	
	add eax, [l_tbl_5+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dl
	jnz	@f
;  End5:
    shr eax, 16
    pop ebx
    ret 4
align 8
  End1:
    pop ebx
    ret  4
align 8
  End2:
    shr eax, 28
    pop ebx
    ret 4
align 8
  End3:
    shr eax, 24
    pop ebx
    ret 4
align 8
  End4:
    shr eax, 20
    pop ebx
    ret 4
align 8
@@:
    add eax, [l_tbl_4+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dh
    jz End6
    add eax, [l_tbl_3+ecx*4-192] 
    pop ebx 
    shr edx, 16
    xor ecx, ecx 	
    add cl, dl
    jz End7
    add eax, [l_tbl_2+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dh
    jz End8
    add eax, [l_tbl_1+ecx*4-192] 
    ret 4
align 8
  End6:
    shr eax, 12
    pop ebx
    ret 4
align 8
  End7:
    shr eax, 8
    ret 4
align 8
  End8:
    shr eax, 4
    ret 4
lingo_htodw endp
lingo_htodw_endp:


.data?
align 16
hxjTable	dd 65536/4 dup(?)	; bytes

.code
align 16
repeat 8
int 3
endm
ax_jj_htodw_s:
an30Sub	dq 3030303030303030h
ax_jj_htodw proc src
	push ecx
	push ebx
	mov ebx, [esp+12]
	movzx edx, word ptr [ebx]
	movq mm7,qword ptr [ebx]
	psubd mm7,qword ptr [an30Sub]
	pmovmskb ecx,mm7
	movzx eax, byte ptr [hxjTable+edx]
	movzx edx, word ptr [ebx+2]
	mov ah, byte ptr [hxjTable+edx]
	bsf ecx,ecx
	bswap eax
	movzx edx, word ptr [ebx+6]
	mov al, byte ptr [hxjTable+edx]
	movzx edx, word ptr [ebx+4]
	neg ecx
	lea ecx,[ecx*4+8*4]
	mov ah, byte ptr [hxjTable+edx]
	pop ebx
	shr eax,cl
	pop ecx
	
	ret 4
	
	align 16
	@ax_jj_htodw_table_init::
	push edi
	push ebx
	mov edi,offset hxjTable	; get table start
	xor ebx, ebx	; outer counter
	.Repeat
		push ebx
		mov eax, ebx
		and ebx, 15
		.if al<"0"
			xor ebx, ebx
		.elseif al>"9"
			add ebx, 9
		.endif
		xor edx, edx
		.Repeat
			mov eax, edx
			.if al<"0"
				xor eax, eax
			.else
				and eax, 15			; isolate nibble
				.if dl>"9"
					add eax, 9			; A
				.endif
			.endif
			shl eax, 4
			add al, bl
			stosb
			inc dl
		.Until Zero?
		pop ebx
		inc bl
	.Until Zero?
	mov byte ptr [edi-65536], -1	; set marker
	pop ebx		; will be pushed again
	pop edi
	retn
	
ax_jj_htodw endp
ax_jj_htodw_endp:



align 16
krbhtodw   PROC lpString:DWORD
;int 3
    mov    edx,[esp+4]
    xor    eax,eax
    push   edi
    push   ebx
    mov    edi,OFFSET cbTable
    Increment TEXTEQU %(0)
    movzx  ecx,BYTE PTR [edx+Increment]
    movzx  ebx,BYTE PTR [ecx+edi]
    test ebx,1000000Y
    jne     Exit
    REPEAT 7
    Increment TEXTEQU %(Increment+1)
    shl    eax,4
    movzx  ecx,BYTE PTR [edx+Increment]
    lea    eax,[eax+ebx]
    movzx  ebx,BYTE PTR [ecx+edi]
    test ebx,1000000Y
    jne     Exit
    ENDM
    shl    eax,4
    lea    eax,[eax+ebx]
Exit:
    pop    ebx
    pop    edi
    ret    4
    
    align  16
    cbTable     BYTE 48 DUP (1000000Y)
                BYTE 0,1,2,3,4,5,6,7,8,9
                BYTE 7 DUP (1000000Y)
                BYTE 10,11,12,13,14,15
                BYTE 26 DUP (1000000Y)
                BYTE 10,11,12,13,14,15
                BYTE 29 DUP (1000000Y)
                BYTE 128 DUP (1000000Y)
    
krbhtodw  ENDP
krbhtodw_endp:



OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start

